/*
  [Header file] 10/20/2003

  'WineWorksShortcutResolver' is a class to parse Windows shortcut (.lnk) files.
  This class is pure C++ and should compile with any compilant compiler.
  This class was written by me for WineWorks, but you are free to use it in your program provided your software is GPLed too.
  An alternative license may be made available if requested.

  Incase you notice BUGs, send a detailed report (and breakpoint if applicable) to <subhobrotosinha at yahoo.com>
 
  Copyright (C) 2004 Subhobroto Sinha <subhobrotosinha at yahoo.com>
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Parts which are (C) WINE, are applicable under the current WINE License (LGPL).
  (However, devoted WINE coders will find that the functions are heavily modified ;)
  Hence, this code will NOT work if simply linked to the original WINE source!)
*/
///////////////////////////////////////////////////////////////////////////
#include <string.h>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include "windatatypes.h"

using namespace std;

typedef struct
{
	/* data structures according to the informations in the lnk */
	ITEMIDLIST	*pPidl;
	WORD		wHotKey;
	SYSTEMTIME	time1;
	SYSTEMTIME	time2;
	SYSTEMTIME	time3;
	DWORD       iShowCmd;
	LPWSTR      sIcoPath;
	INT         iIcoNdx;
	LPWSTR      sPath;
	LPWSTR      sArgs;
	LPWSTR      sWorkDir;
	LPWSTR      sDescription;
	LPWSTR      sPathRel;
}WhatTheHeckDataType;
///////////////////////////////////////////////////////////////////////////
class WineWorksShortcutResolver
{
  ifstream oifstrStr;
  WhatTheHeckDataType wthdtMe;

  LPPIDLDATA _dbg_ILGetDataPointer(LPCITEMIDLIST pidl);
  LPITEMIDLIST _dbg_ILGetNext(LPCITEMIDLIST pidl);
  BOOL _dbg_ILIsDesktop(LPCITEMIDLIST pidl);
  LPSTR _dbg_ILGetTextPointer(LPCITEMIDLIST pidl);
  DWORD _dbg_ILSimpleGetText(LPCITEMIDLIST pidl,LPSTR szOut,UINT uOutSize);
  unsigned int UnicodeToANSI(const WCHAR* wszInUnicode,unsigned int uiLen,char* szOutANSI);
  unsigned int ANSIToUnicode(const char* szInANSI,unsigned int uiANSILen,WCHAR* wszOutUnicode);
  HRESULT Stream_LoadLocation();
  HRESULT Stream_LoadString(LPWSTR& pstr);
  BOOL LoadShortcut();

public:

  WineWorksShortcutResolver();
  ~WineWorksShortcutResolver();
  WineWorksShortcutResolver(const char* lpszFileName);
  
  DWORD  GetPath(char* lpszPath);
  DWORD  GetArgs(char* lpszArgs);
  DWORD  GetWorkDir(char* lpszWorkDir);
  DWORD  GetDescription(char* lpszDescription);
  DWORD  GetPathRel(char* lpszPathRel);
};
