/*
Copyrighted (C)2004 by Subhobroto Sinha under the GNU GPL v2.
Dated: 10/20/2003

Comments:
--------

These are approximate definitions. I am NOT sure if the data types have been aliased properly by me.
I have made a few guesses. They seem to work allright.(They are mnemonics really..)
Anybody with a Windows box might be able to verify my guesses..
The data types are actually cascading types..

Other data types due to WINE (they start from 'typedef struct  __FILETIME__'..) and thus are applicable to the current WINE license (LGPL)

Please send reports to <subhobrotosinha at yahoo dot com>
*/

#define MAX_PATH          260

typedef int               BOOL;
typedef char*             LPSTR;
typedef float             FLOAT;
typedef unsigned char     BYTE;
typedef unsigned int      UINT;
typedef unsigned short    WORD;
typedef unsigned short    USHORT;
typedef unsigned char*    LPBYTE;
typedef unsigned long     DWORD;
typedef unsigned long     ULONG;
//typedef unsigned short    wchar_t;
typedef char              CHAR;
typedef int               INT;
typedef long              LONG;
typedef LONG              HRESULT;
//typedef wchar_t           WCHAR;
typedef unsigned short    WCHAR;
typedef WCHAR             TCHAR;
typedef WCHAR             *LPWSTR;
typedef TCHAR             *LPTSTR;
typedef const WCHAR       *LPCWSTR;
typedef const TCHAR       *LPCTSTR;

typedef struct  __FILETIME__
{
    unsigned long dwLowDateTime;
    unsigned long dwHighDateTime;
}FILETIME;

typedef struct  _SYSTEMTIME
{
    WORD wYear;
    WORD wMonth;
    WORD wDayOfWeek;
    WORD wDay;
    WORD wHour;
    WORD wMinute;
    WORD wSecond;
    WORD wMilliseconds;
}SYSTEMTIME;

typedef struct  _GUID
{
    DWORD Data1;
    WORD Data2;
    WORD Data3;
    BYTE Data4[ 8 ];
}GUID;

#define PT_DESKTOP	0x00 /* internal */
#define PT_MYCOMP	0x1F
#define PT_DRIVE	0x23
#define PT_DRIVE2	0x25
#define PT_DRIVE3	0x29
#define PT_SPECIAL	0x2E
#define PT_DRIVE1	0x2F
#define PT_FOLDER1	0x30
#define PT_FOLDER	0x31
#define PT_VALUE	0x32
#define PT_WORKGRP	0x41
#define PT_COMP		0x42
#define PT_NETPROVIDER  0x46
#define PT_NETWORK	0x47
#define PT_IESPECIAL1	0x61
#define PT_IESPECIAL2	0xb1
#define PT_SHARE	0xc3
/* flag1: lnk elements: simple link has 0x0B */
#define SCF_PIDL		0x01
#define SCF_NORMAL		0x02
#define SCF_DESCRIPTION 0x04
#define SCF_RELATIVE	0x08
#define SCF_WORKDIR		0x10
#define SCF_ARGS		0x20
#define SCF_CUSTOMICON  0x40
#define SCF_UNC			0x80
#define S_OK            ((HRESULT)0x00000000L)
////////////////////////////////////////////////

typedef BYTE PIDLTYPE;

typedef struct tagPIDLDATA
{	PIDLTYPE type;			/*00*/
	union
	{ struct
	  { BYTE dummy;			/*01*/
	    GUID guid;			/*02*/
	    BYTE dummy1;		/*18*/
	  } mycomp;
	  struct
	  { CHAR szDriveName[20];	/*01*/
	    DWORD dwUnknown;		/*21*/
	    /* the drive seems to be 25 bytes every time */
	  } drive;
	  struct
	  { BYTE dummy;			/*01 is 0x00 for files or dirs */
	    DWORD dwFileSize;		/*02*/
	    WORD uFileDate;		/*06*/
	    WORD uFileTime;		/*08*/
	    WORD uFileAttribs;		/*10*/
	    CHAR szNames[1];		/*12*/
	    /* Here are comming two strings. The first is the long name.
	    The second the dos name when needed or just 0x00 */
	  } file, folder, generic;
	  struct
	  { WORD dummy;		/*01*/
	    CHAR szNames[1];	/*03*/
	  } network;
	  struct
	  { WORD dummy;		/*01*/
	    DWORD dummy1;	/*02*/
	    CHAR szName[1];	/*06*/ /* teminated by 0x00 0x00 */
	  } htmlhelp;
	}u;
} PIDLDATA, *LPPIDLDATA;

typedef struct _LINK_HEADER
{
	DWORD    MagicStr;	/* 0x00 size of the header - 0x4c */
	GUID     MagicGuid;	/* 0x04 is CLSID_ShellLink */
	DWORD    dwFlags;	/* 0x14 describes elements following */
	DWORD    dwFileAttr;	/* 0x18 attributes of the target file */
	FILETIME Time1;		/* 0x1c */
	FILETIME Time2;		/* 0x24 */
	FILETIME Time3;		/* 0x2c */
	DWORD    dwFileLength;	/* 0x34 File length of target file*/
	DWORD    nIcon;		/* 0x38 icon number */
	DWORD	 fStartup;	/* 0x3c startup type. 1 => Normal window; 3=>Maximized 7 => Minimized*/
	DWORD	 wHotKey;	/* 0x40 hotkey */
	DWORD	 Unknown5;	/* 0x44 */
	DWORD	 Unknown6;	/* 0x48 */
} LINK_HEADER, * PLINK_HEADER;
typedef struct _SHITEMID // mkid
{
	USHORT cb; // Size of the ID (including cb itself)
	BYTE abID[1]; // The item ID (variable length)
}SHITEMID;
typedef struct _ITEMIDLIST // idl
{
	SHITEMID mkid;
}ITEMIDLIST, * LPITEMIDLIST;
typedef const LPITEMIDLIST LPCITEMIDLIST;

typedef struct _LOCATION_INFO
{
    DWORD  dwTotalSize;
    DWORD  dwHeaderSize;
    DWORD  dwFlags;
    DWORD  dwVolTableOfs;
    DWORD  dwLocalPathOfs;
    DWORD  dwNetworkVolTableOfs;
    DWORD  dwFinalPathOfs;
}LOCATION_INFO;
